summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorJonathan Maw <jonathan.maw@codethink.co.uk>2012-11-29 16:13:48 +0000
committerJonathan Maw <jonathan.maw@codethink.co.uk>2012-11-29 17:03:08 +0000
commit36100edc77e8245b080343e12f59c26e35d66f2e (patch)
tree006f8559ab7de8fe84f9c20a712c588af948a106
parentc859d70d86423a52bc7053abf64e9ca21f62a487 (diff)
downloadmorph-36100edc77e8245b080343e12f59c26e35d66f2e.tar.gz
Avoid rebuilds when unimportant morphology contents change
This changes the cache key generation so that it will ignore unimportant fields of the morphology, e.g. description, build-depends, chunks. description is unimportant because it does not affect building, and build-depends/chunks are unimportant because they are already considered
-rw-r--r--morphlib/cachekeycomputer.py8
-rwxr-xr-xtests.as-root/unimportant-morphology-contents-do-not-change-cache-keys.script41
2 files changed, 49 insertions, 0 deletions
diff --git a/morphlib/cachekeycomputer.py b/morphlib/cachekeycomputer.py
index a11334e3..a4ea10ed 100644
--- a/morphlib/cachekeycomputer.py
+++ b/morphlib/cachekeycomputer.py
@@ -91,6 +91,14 @@ class CacheKeyComputer(object):
elif kind in ('system', 'stratum'):
morphology = artifact.source.morphology
le_dict = dict((k, morphology[k]) for k in morphology.keys())
+
+ # Disregard all fields of a morphology that aren't important
+ ignored_fields = ('strata', 'build-depends', 'description',
+ 'chunks')
+ for ignored_field in ignored_fields:
+ if ignored_field in le_dict:
+ del le_dict[ignored_field]
+
checksum = hashlib.sha1()
self._hash_thing(checksum, le_dict)
keys['morphology-sha1'] = checksum.hexdigest()
diff --git a/tests.as-root/unimportant-morphology-contents-do-not-change-cache-keys.script b/tests.as-root/unimportant-morphology-contents-do-not-change-cache-keys.script
new file mode 100755
index 00000000..27adf8c6
--- /dev/null
+++ b/tests.as-root/unimportant-morphology-contents-do-not-change-cache-keys.script
@@ -0,0 +1,41 @@
+#!/bin/bash
+#
+# Copyright (C) 2012 Codethink Limited
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+## Some contents of morphologies (description, build-depends, chunks)
+## should not change the cache keys of those morphs because they are
+## either already considered (build-depends and chunks) or do not affect
+## building (description). This test checks that changes to these parts
+## of a morphology do not force rebuilds.
+
+set -eu
+
+# Disable test on versions of Python before 2.7.
+source "$SRCDIR/scripts/python-check"
+
+source "$SRCDIR/tests.as-root/setup-build"
+
+# Build once.
+cd "$DATADIR/workspace"
+"$SRCDIR/scripts/test-morph" build linux-system
+ARTIFACT_COUNT="$(ls "$DATADIR/cache/artifacts" | wc -l)"
+
+# Petrify the refs, so the morphologies will be different
+"$SRCDIR/scripts/test-morph" petrify
+
+# Build with the petrified morphologies.
+"$SRCDIR/scripts/test-morph" build linux-system
+[ "$ARTIFACT_COUNT" -eq $(ls "$DATADIR/cache/artifacts" | wc -l) ]